/*
 * Copyright (c) 2018-2999 广州亚米信息科技有限公司 All rights reserved.
 *
 * https://www.gz-yami.com/
 *
 * 未经允许，不可做商业用途！
 *
 * 版权所有，侵权必究！
 */

package com.yami.shop.service;

import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.yami.shop.bean.dto.ListCategoryDTO;
import com.yami.shop.bean.model.Category;
import com.yami.shop.bean.vo.ListCategoryForUserVO;
import com.yami.shop.bean.vo.ListCategoryVO;
import org.springframework.web.multipart.MultipartFile;

/**
 * 商品分类
 */
public interface CategoryService extends IService<Category> {

	/**
	 * 保存分类、品牌、参数
	 * @return
	 */
	void saveCategroy(Category category);

	/**
	 * 修改分类、品牌、参数
	 * @return
	 */
	void updateCategroy(Category category);

	/**
	 * 删除分类、品牌、参数 以及分类对应的图片
	 * @return
	 */
	void deleteCategroy(Category category);

	/**
	 * 通过分类id和店铺id获取分类信息
	 * @param categoryId
	 * @param shopId
	 * @return
	 */
	Category getCategoryByCategoryIdAndShopId(Long categoryId, Long shopId);

	/**
	 * 根据店铺id和顶级分类id，获取分类
	 * @param parentId
	 * @param shopId
	 * @return
	 */
	IPage<Category> listByParentIdAndShopId(Long parentId, Long shopId, Integer current, Integer size);

	/**
	 * 根据店铺id获取分类
	 * @param parentId
	 * @param shopId
	 * @return
	 */
	List<Category> listByShopId(Long shopId);

	/**
	 * 分类查询
	 * */
	IPage<ListCategoryVO> listCategory(ListCategoryDTO listCategoryDTO);

	Object parseCategoryFile(MultipartFile excelFile, Long shopId) throws Exception;

	/**
	 * 用户端分类查询
	 * */
	List<ListCategoryForUserVO> listCategoryForUser(Long channelId,Long shopId);

}
